#!/usr/bin/python

"""Test to verify bug #385828 is still fixed.
   Can not use agenda wizard in OpenOffice.org.
"""

from macaroon.playback import *
import utils

sequence = MacroSequence()

######################################################################
# 1. Start oowriter.
#
sequence.append(WaitForWindowActivate("Untitled[ ]*1 - " + utils.getOOoName("Writer"),None))
sequence.append(WaitForFocus("", acc_role=pyatspi.ROLE_PARAGRAPH))

######################################################################
# 2. Enter Alt-f, to display the File menu.
#
sequence.append(KeyComboAction("<Alt>f"))
sequence.append(WaitForFocus("New", acc_role=pyatspi.ROLE_MENU))

######################################################################
# 3. Press "w" to open the Wizards submenu.
#
sequence.append(TypeAction("w"))
sequence.append(WaitForFocus("Letter...", acc_role=pyatspi.ROLE_MENU_ITEM))

######################################################################
# 4. Press "a" to bring up the Agenda... wizard.
#
sequence.append(utils.StartRecordingAction())
sequence.append(TypeAction("a"))
sequence.append(WaitForWindowActivate("aw-5blue (read-only) - " + utils.getOOoName("Writer"),None))
sequence.append(WaitForFocus("Page design", acc_role=pyatspi.ROLE_LABEL))
sequence.append(utils.AssertPresentationAction(
    "Press 'a' to bring up the Agenda... wizard",
    ["BRAILLE LINE:  'soffice Application aw-5blue (read-only) - " + utils.getOOoName("Writer") + " Frame (1 dialog)'",
     "     VISIBLE:  'aw-5blue \(read-only\) - " + utils.getOOoName("Writer")[0:9] + "', cursor=1",
     "BRAILLE LINE:  'soffice Application Agenda Wizard Dialog'",
     "     VISIBLE:  'Agenda Wizard Dialog', cursor=1",
     "BRAILLE LINE:  'soffice Application Agenda Wizard Dialog Agenda Wizard OptionPane Steps Panel  $l'",
     "     VISIBLE:  '  $l', cursor=1",
     "SPEECH OUTPUT: 'aw-5blue (read-only) - " + utils.getOOoName("Writer") + " frame 1 unfocused dialog'",
     "SPEECH OUTPUT: 'Agenda Wizard Please choose the page design for the agenda 1. Page design 2. General information 3. Headings to include 4. Names 5. Agenda items 6. Name and location'",
     "SPEECH OUTPUT: ''",
     "SPEECH OUTPUT: 'Page design label'"]))

######################################################################
# 5. Press Escape to put focus back in the document.
#
sequence.append(KeyComboAction("Escape"))
sequence.append(WaitForFocus("", acc_role=pyatspi.ROLE_PARAGRAPH))

######################################################################
# 6. Wait for things to get back to normal.
#
sequence.append(PauseAction(3000))

sequence.append(utils.AssertionSummaryAction())

sequence.start()
